#cloud-config

groups:
  - sysadmins

users:
  - name: ansibleusr
    shell: /bin/bash
    groups: sysadmins
  - name: theo-agent
    shell: /bin/false
    system: true

write_files:
  - path: /etc/sudoers.d/50-sysadmins
    owner: root:root
    permissions: '0440'
    content: |
      %sysadmins ALL=(ALL) NOPASSWD: ALL
  - path: /etc/theo-agent/public.pem
    owner: root:root
    permissions: '0644'
    content: |
      -----BEGIN PUBLIC KEY-----
      MIICIjANBgkqhkiG9w0BAQEFAAOCAg8AMIICCgKCAgEA3gGExRviVBMSL0SZ9Ce9
      99eWED96iPSKfmjv8Iz3faLmPLKWRDOaxwNdU8Sg48O9IEcAEbgx3jgubNLthiRB
      U+F5N00ZpFHXByc7h2FxD/JMzxoyxDYSdaQ+JHt+GNYmFA6DYpE6KPaISrWjXgGT
      KTzN3135qK14ByI0wOUHKESAKPRf/ZMPclwBxEDlfvrn0V1fjBzP1Xbnxv5LFWSl
      CPGvUA7+msqcHdq0Ep3UPJbnSWO3HhynVevkgj0zVW1GKeps+fa+GFvcyD4N53Ya
      uGZDefqZgfRxDXrb+vOtiOpVDVvIoicZPt2To9Cd4frpYtNWstDisDoLQBDc6v3p
      26OmSZlXbCZbEGyknJ7pz/bpOqRpNlElmfGVDKTmX5OAgL2dk1UdDzuxm/WlPXFv
      SQv9/heZOiYuW7haMHkCELnk8kWnaUxKDC6+Hma8GLVgCP4YjUkpkU7FJD6wksKc
      U408zgEEBWsk31KtA0BVS8462N24LunQcpB98ZAnL343SkrQcu/n/Nd9DTofInyP
      NVIt7Sq1C0OqBFic+YoJTgig4mYAIbxGIhai/03IlkVzOf5AuAAX8ddbWX3k5Lnn
      xFKLuHu71khcDaB1Jn7K22sN5meg+6qAED/xJV7bDXwVyBiknCwMxAiHfz0+kTyI
      Ugm7jhITOZ0cipYzvPrwIWcCAwEAAQ==
      -----END PUBLIC KEY-----
  - path: /usr/sbin/download-install-theo.sh
    owner: root:root
    permissions: '0755'
    content: |
      #!/bin/bash
      THEO_AGENT_LATEST=$(curl -L -s -H 'Accept: application/json' https://github.com/theoapp/theo-agent/releases/latest |sed -e 's/.*"tag_name":"\([^"]*\)".*/\1/')
      sudo curl -L -o /usr/sbin/theo-agent \
        https://github.com/theoapp/theo-agent/releases/download/$${THEO_AGENT_LATEST}/theo-agent-$(uname -s)-$(uname -m)
      chmod 755 /usr/sbin/theo-agent
      /usr/sbin/theo-agent \
        -install \
        -verify \
        -public-key /etc/theo-agent/public.pem \
        -no-interactive \
        -sshd-config \
        -url https://fluidware.authkeys.io \
        -token ${theo_token}
        -hostname-prefix fcub-
      chown -R theo-agent /etc/theo-agent
      chmod 700 /etc/theo-agent
      selinuxenabled 2>/dev/null && semanage permissive -a sshd_t
runcmd:
  - /usr/sbin/download-install-theo.sh
  - systemctl restart ssh.service
